﻿;==========================================================================================================================================================
; Freak, Srod, Sparkie, Richedit handling
;==========================================================================================================================================================

Declare.i CatchRTF(Gadget.i, MemoryAddress.i)                                                       ; Load an RTF text file from datasection and put it into the editorgadget (By Freak I think)
Declare   CatchRTF_Callback(dwCookie.i, pbBuff.i, cb.i, *pcb.LONG)                                  ; Callback used by CatchRFT to stream an RTF text file fron datasection and put it into the editorgadget
Declare   GetRTF(Gadget.i, Address.i)                                                               ; Stream the RTF data from the requested gadget
Declare.i GetRTFCallback(dwCookie.i, pbBuff.i, cb.i, *pcb.LONG)                                     ; Callback for the RTF stream requester
Declare.i GetRTFLen(Gadget.i)                                                                       ; Get the length of RTF data in the requested gadget
Declare.i GetRTFLenCallback(dwCookie.i, pbBuff.i, cb.i, *pcb.LONG)                                  ; Callback for the RTF length retriever
Declare.s GetRtfData(Gadget.i)                                                                      ; Get RTF data from the requested gadget

;========================================================================================================================================
; NetMaestro's mouse hover events code
;========================================================================================================================================

Declare   NM_Hover()                                                                                ; NetMaestro's Hover library
Declare   SetHoverIcons(Gadget.i, Image.i)                                                          ; Set the correct icons to the selected hoverable gadget

;==========================================================================================================================================
; Generic modules
;==========================================================================================================================================

Declare   ChangeIcon(mygadget.i, myrow.i, mycolumn.i, myicon.i)                                     ; Update each collumn of a ListIconGadget with a user defined icon as needed
Declare.s FormatField(InString.s, FieldLen.i)                                                       ; Format the passed string to the correct field length for printing
Declare.s KillQuote(Instring.s)                                                                     ; Kill double quotes in strings for display purposes
Declare.s GetShortcutText(Constant.i)                                                               ; Get the text of the associated shortcut constant
Declare   LastLine(Gadget.i, LineNumber.i)                                                          ; Go to the last line of a ListIconGadget
Declare   RemoveBorders(GadgetConstant.i)                                                           ; Remove borders from various gadgets
Declare.s RepQuote(Instring.s)                                                                      ; Uncle Berikco's routine to properly replace single quotes with double for SQL passing
Declare.s SetSearchQuery(SearchOperator.s, SearchString.s)                                          ; Alias the search type text to SQLite operators
Declare   StringFirstUpper(GadgetId.i)                                                              ; Convert the first character of a string to uppercase
Declare.s TextToXML(TextString.s)                                                                   ; Replace bad characters with XML compatible ones. Thorsten Hoeppner
Declare.s XMLToText(XMLString.s)                                                                    ; Strip illegal characters from text strings

;==========================================================================================================================================
; Custom include files
;==========================================================================================================================================

Declare   AsyncTimer(ObjectHandle.i, Message.i, EventNumber.i, TimePeriod.i)                        ; Run an asynchronous clock in the window title bar
Declare   BuildImageList(GadgetId)                                                                  ; Rebuild the image list as it gets trashed by the clear command
Declare   CloseMyWindow(Window.i)                                                                   ; Fade the window out gently, close it and reset the mutex
Declare.s FormatMenu(HeadingString.s, ShortcutString.s, FieldLen.i)                                 ; Format menu text and shortcut strings to nice length
Declare.s IsoDate(DateString.s, Direction.s)                                                        ; Convert an ISO format date to Australian and back
Declare.s LocalTime(TimeToFix.s)                                                                    ; Convert from 12 to 24 hour mode and back
Declare   MakeSureDirectoryPathExists(Directory.s)                                                  ; Need a unicode aware version of the API directory creator
Declare   ReadProgramOptions()                                                                      ; Read the program toggles from the database
Declare   SaveProgramOptions()                                                                      ; Save all the program options whenever you need to
Declare   SetInfoBarArea(FieldName.s, FieldStatus.s, MessageContent.s = "0", ModuleName.s = "")     ; Send messages and error reports to the fake status bar area
Declare   SetListIconHeaderTest()                                                                   ; Set the heading of a ListIconGadget based on what you are hovering over
Declare   SetupAppointments()                                                                       ; Setup various program options and switches
Declare   SetupAppointmentsSave()                                                                   ; Save all the setup variables to database
Declare   WindowCallback(WindowID.i, Message.i, wParam.i, lParam.i)                                 ; Window snap, strikeoutfont and more
Declare   WriteErrorLog()                                                                           ; Write the error log to disk at program's end or when full

;==========================================================================================================================================================
; Help and information menus
;==========================================================================================================================================================

Declare   AboutAppointments()                                                                       ; AppointmentMuncher 'About' window
Declare   HelpAppointments()                                                                        ; Show an RTF help file loaded into this window
Declare   KeysAppointments()                                                                        ; Show a list of all the keyboard shortcuts

;==========================================================================================================================================================
; Various program toggles
;==========================================================================================================================================================

Declare   ToggleBalloonToolTips()                                                                   ; Turn the balloon tooltips on or off. No need to remove them
Declare   ToggleStickyWindow()                                                                      ; Change the desktop from on top to under others
Declare   ToggleTitleClock()                                                                        ; Turn the titlebar clock on or off
Declare   ToggleScreenSnap()                                                                        ; Turn snapping to screen borders on and off
Declare   ToggleEmailAlarm()                                                                        ; Turn on sending of email appointments
Declare   ToggleAutoArchive()                                                                       ; Turn on automatic appointment archiving

;==========================================================================================================================================================
; Minimising and maximising the program window
;==========================================================================================================================================================

Declare   HideProgramWindow()                                                                       ; Hide the program window
Declare   ShowProgramWindow()                                                                       ; Show the program window

;==========================================================================================================================================
; Balloon and tooltip handling
;==========================================================================================================================================

Declare   BalloonTip(pbGadgetNumber.i, pbFontHandle.i, balloonColour.i, balloonTipTitle.s, balloonTipText.s,  pbIconHandle.i) ; Add balloon tooltips with individual fonts And icons
Declare.i GetIconHandle(ImageConstant.i)                                                            ; Copy the icon into memory while deleting the original image copied from

;==========================================================================================================================================
; Database functions
;==========================================================================================================================================

Declare.s CountRecords(TableField.s, TableName.s)                                                   ; Count the number of records in an SQLite database
Declare.s DatabaseLastInsertRowId()                                                                 ; Get the ID of the last inserted record
Declare.s LastRecord(TableName.s)                                                                   ; Find the last record number in the database, not necessarily the last record though due to deletions (fang)
Declare   OpenSystemDatabase()                                                                      ; Try to open the system database and create missing tables

;========================================================================================================================================
; Alarm checking routines. This is where I am going to have trouble
;========================================================================================================================================

Declare   CancelCurrentAppointment()                                                                ; Cancel the current appointment. Sets it as a finished task
Declare   ChangeAlarmCheckTime()                                                                    ; Change the time for alarm checks. Global
Declare   CheckAppointments(ObjectHandle.i, Message.i, EventNumber.i, TimePeriod.i)                 ; Run a timed background check of current appointments
Declare   ShowAppointmentAlarmComment()                                                             ; Show the comment for an alarm when the list is clicked on
Declare   SnoozeCurrentAppointment()                                                                ; Close the current appointment, doesn't change the status
Declare   SpawnAlarmWindow()                                                                        ; Spawn an alarm window for each alarm that needs to open

;==========================================================================================================================================================
; Export and import routines
;==========================================================================================================================================================

Declare   ExportAppointments()                                                                      ; Export appointment data to a standard XML file
Declare   ImportAppointments()                                                                      ; Import appointmentmuncher files from disk
Declare   ProcessAppointmentNode(*CurrentNode, CurrentSublevel.i)                                   ; Process the current AppointmentMuncher XML child node

;==========================================================================================================================================================
; Backup archive table
;==========================================================================================================================================================

Declare   ArchiveCurrentAppointment()                                                               ; Archive a copy of the selected record to the archive table
Declare   ArchiveNewAppointment(RecordNumber.s)                                                     ; Archive a newly added appointment
Declare   DeleteArchivedAppointment()                                                               ; 
Declare   DisplayArchiveString(LineNumber.i, DisplayMode.s)                                         ; Handle all list display jobs from add, edit, list, import modes etc
Declare   FindArchivedAppointmentNow()                                                              ; 
Declare   HelpArchivedAppointments()                                                                ; 
Declare   PrintArchivedAppointments()                                                               ; 
Declare   RestoreArchivedAppointment()                                                              ; Restore an archived copy of an appointment To the main appointments table
Declare   ShowArchivedAppointments()                                                                ; Load the list of archived appointments
Declare   ShowArchivedAppointmentComment()                                                          ; Show the comment for the current archived appointment
Declare   UpdateArchivedAppointment(RecordNumber.s)                                                 ; Update the archived copy of the appointment being edited (If any)

;========================================================================================================================================
; Data handing routines
;========================================================================================================================================

Declare   AddNewAppointment()                                                                       ; Add a new appointment to the list
Declare   CleanAppointments()                                                                       ; Permanently clean appointments marked deleted from the database
Declare   CopySelectedAppointments()                                                                ; Copy highlighted appointment to the system clipboard
Declare   DeleteSelectedAppointments()                                                              ; Delete all the selected appointments
Declare   DisplayAppointmentString(LineNumber.i, DisplayMode.s)                                     ; Handle all list display jobs from add, edit, list, import modes etc
Declare   DisplayRecordData()                                                                       ; Display the current record data
Declare   EditSelectedAppointment()                                                                 ; Edit the selected appointment
Declare   FindAppointments()                                                                        ; Find appointments with more advanced SQL queries
Declare   FindAppointmentsNow()                                                                     ; Find appointments when the find button is pressed
Declare   ListAppointments(DisplayType.s)                                                           ; List all appointments at startup
Declare   PrintAppointments()                                                                       ; Print all selected appointments
Declare   SaveAppointmentData()                                                                     ; Save the new or edited appointment data
Declare   SearchAppointments()                                                                      ; Seach for appointmnents inside a specific choice
Declare   UndeleteSelectedAppointments()                                                            ; Undelete the selected appointments

; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 34
; FirstLine = 16
; EnableXP