﻿;==========================================================================================================================================================
; Handle all list display jobs from add, edit, list, import modes etc
;==========================================================================================================================================================

Procedure DisplayArchiveString(LineNumber.i, DisplayMode.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select DisplayMode.s
      
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Case  "AddMode"
    
      ;--------------------------------------------------------------------------------------------
      ; Add appointments to the list
      ;--------------------------------------------------------------------------------------------
      
      With Appointment
        
        ;------------------------------------------------------------------------------------------
        
        appComment.s = ReplaceString(\appComment,   Chr(10), " ")
        
        appComment.s = ReplaceString(appComment.s,  Chr(13), " ")
        
        appComment.s = ReplaceString(appComment.s,  "  ",    " ")
        
        ;------------------------------------------------------------------------------------------
        
        ListString.s =               \appName                                             + Chr(10) ;: Debug \appName
        
        ListString.s +               \appDate                                             + Chr(10) ;: Debug \appDate
        
        ;------------------------------------------------------------------------------------------
        
        If \appTime <> ""
          
          ListString.s +   LocalTime(\appTime)                                            + Chr(10) ;: Debug \appTime
          
        Else
          
          ListString.s +             "00:00"                                              + Chr(10) ;: Debug \appTime
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        
        If \appAlarm <> ""
          
          ListString.s +             \appAlarm                                            + Chr(10) ;: Debug \appAlarm
          
        Else
          
          ListString.s +             "00/00/0000"                                         + Chr(10) ;: Debug \appAlarm
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        
        ListString.s +               \appRepeat                                           + Chr(10) ;: Debug \appRepeat
        
        ListString.s +               \appProtect                                          + Chr(10) ;: Debug \appProtect
        
        ListString.s +               \appCategory                                         + Chr(10) ;: Debug \appCategory
        
        ListString.s +               \appStatus                                           + Chr(10) ;: Debug \appStatus
        
        ListString.s +                appComment.s                                        + Chr(10) ;: Debug \appComment
        
        ListString.s +               \AppArchived                                         + Chr(10) ;: Debug \AppArchived
        
        ListString.s +               \appEmailed                                          + Chr(10) ;: Debug \appEmailed
        
        ListString.s +               \appSound                                            + Chr(10) ;: Debug \appSound
        
        ListString.s +               \appDeleted                                          + Chr(10) ;: Debug \appDeleted
        
        ListString.s +               \appRecord                                                     ;: Debug \appRecord
        
                                                                                                    ;: Debug "--------------------------------------------------"
                                                                                                    ;: Debug ListString.s
                                                                                                    ;: Debug "--------------------------------------------------"
                                                                                                    
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        AddGadgetItem(#Gadget_AppointmentArchive_Appointments, -1,  ListString.s)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        ListString.s = ""
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        LastLine(#Gadget_AppointmentArchive_Appointments, LineNumber.i)
          
        ;------------------------------------------------------------------------------------------
        ; Set the currently highlighted line
        ;------------------------------------------------------------------------------------------
          
        SetGadgetState(#Gadget_AppointmentArchive_Appointments, LineNumber.i)
          
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        DisplayRecordData()
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      EndWith

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; Select the correct category icon into the first column
  ;------------------------------------------------------------------------------------------------
  
  If Appointment\appDeleted <> "1"
    
    Select Appointment\appCategory
        
      Case  "Unknown"           : CategoryIcon.i  = Icon\CatUnknown
        
      Case  "Aeroplane"         : CategoryIcon.i  = Icon\CatAeroplane
        
      Case  "Amateur"           : CategoryIcon.i  = Icon\CatAmateur
        
      Case  "Ambulance"         : CategoryIcon.i  = Icon\CatAmbulance
        
      Case  "Anyu"              : CategoryIcon.i  = Icon\CatAnyu
        
      Case  "Bank"              : CategoryIcon.i  = Icon\CatBank
        
      Case  "Bus"               : CategoryIcon.i  = Icon\CatBus
        
      Case  "Business"          : CategoryIcon.i  = Icon\CatBusiness
        
      Case  "Camel"             : CategoryIcon.i  = Icon\CatCamel
        
      Case  "Cbradio"           : CategoryIcon.i  = Icon\CatCbradio
        
      Case  "Cfa"               : CategoryIcon.i  = Icon\CatCfa
        
      Case  "Charity"           : CategoryIcon.i  = Icon\CatCharity
        
      Case  "Dentist"           : CategoryIcon.i  = Icon\CatDentist
        
      Case  "Doctor"            : CategoryIcon.i  = Icon\CatDoctor
        
      Case  "Fire"              : CategoryIcon.i  = Icon\CatFire
        
      Case  "Fireman"           : CategoryIcon.i  = Icon\CatFireman
        
      Case  "Hospital"          : CategoryIcon.i  = Icon\CatHospital
        
      Case  "Medical"           : CategoryIcon.i  = Icon\CatMedical
        
      Case  "Optometrist"       : CategoryIcon.i  = Icon\CatOptometrist
        
      Case  "Personal"          : CategoryIcon.i  = Icon\CatPersonal
        
      Case  "Physiotherapist"   : CategoryIcon.i  = Icon\CatPhysiotherapist
        
      Case  "Police"            : CategoryIcon.i  = Icon\CatPolice
        
      Case  "Scouts"            : CategoryIcon.i  = Icon\CatScouts
        
      Case  "Service"           : CategoryIcon.i  = Icon\CatService
        
      Case  "Shopping"          : CategoryIcon.i  = Icon\CatShopping
        
      Case  "Taxi"              : CategoryIcon.i  = Icon\CatTaxi
        
      Case  "Tradesman"         : CategoryIcon.i  = Icon\CatTradesman
        
      Case  "Train"             : CategoryIcon.i  = Icon\CatTrain
        
      Case  "Truck"             : CategoryIcon.i  = Icon\CatTruck
        
      Case  "Veterinarian"      : CategoryIcon.i  = Icon\CatVeterinarian
        
    EndSelect
    
    ChangeIcon(#Gadget_AppointmentArchive_Appointments, LineNumber.i, Program\NameColumn, CategoryIcon.i)
    
;     Debug "Category         " + Appointment\appCategory
;     Debug "Line             " + Str(LineNumber.i)
;     Debug "Image number     " + Str(CategoryIcon.i)
;     Debug "Image id         " + Str(CurrentImageId.i)
    
  Else
    
    ;------------------------------------------------------------------------------------------
    ; Redraw a line in the gadget for the strikeout font to display
    ;------------------------------------------------------------------------------------------

    SetGadgetItemData(#Gadget_AppointmentArchive_Appointments,  LineNumber.i, Val(Appointment\appDeleted ))
    
    RedrawWindow_(GadgetID(#Gadget_AppointmentArchive_Appointments), 0, 0, #RDW_INVALIDATE | #RDW_ERASE)
    
    ChangeIcon(#Gadget_AppointmentArchive_Appointments, LineNumber.i, Program\NameColumn, Icon\ListDeleted)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Show the active or stopped icon
  ;------------------------------------------------------------------------------------------------
  
  Select Appointment\appStatus
      
    Case  "Active appointment"    : ChangeIcon(#Gadget_AppointmentArchive_Appointments, LineNumber.i, Program\DateColumn, Icon\StatusActive)
      
    Case  "Finished appointment"  : ChangeIcon(#Gadget_AppointmentArchive_Appointments, LineNumber.i, Program\DateColumn, Icon\StatusFinished)
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; Select the correct alarm time of day icon.   yrreti code
  ;------------------------------------------------------------------------------------------------
  
  HourCheck.i  = Val(ReplaceString(Appointment\appTime, ":", "", 1))
  
  Select HourCheck.i
      
    Case    0 To 1159, 2400 : ChangeIcon(#Gadget_AppointmentArchive_Appointments, LineNumber.i, Program\TimeColumn, Icon\LightMorning)
      
    Case 1200 To 1759       : ChangeIcon(#Gadget_AppointmentArchive_Appointments, LineNumber.i, Program\TimeColumn, Icon\LightNoon)
      
    Case 1800 To 2359       : ChangeIcon(#Gadget_AppointmentArchive_Appointments, LineNumber.i, Program\TimeColumn, Icon\LightNight)
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; Select the correct alarm icon.
  ;------------------------------------------------------------------------------------------------
  
  If Appointment\appAlarm <> ""
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------    
    
    AppointmentAlarm.i  = ParseDate("%dd/%mm/%yyyy", Appointment\appAlarm)  ; Turn text date into date integer
    
    CurrentDate.i       = ParseDate("%dd/%mm/%yyyy", Program\CurrentDate)   ; Turn text date into date integer
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------    
    
    If AppointmentAlarm.i < CurrentDate.i       ; If alarm date is less than today's date
      
      ChangeIcon(#Gadget_AppointmentArchive_Appointments, LineNumber.i, Program\AlarmColumn, Icon\AlarmRed)
      
    ElseIf  AppointmentAlarm.i = CurrentDate.i ; If alarm date equals today's date
      
      ChangeIcon(#Gadget_AppointmentArchive_Appointments, LineNumber.i, Program\AlarmColumn, Icon\AlarmGreen)
      
    ElseIf  AppointmentAlarm.i > CurrentDate.i ; If alarm date is greater than today's date
      
      ChangeIcon(#Gadget_AppointmentArchive_Appointments, LineNumber.i, Program\AlarmColumn, Icon\AlarmBlue)
      
    Else
      
      ChangeIcon(#Gadget_AppointmentArchive_Appointments, LineNumber.i, Program\AlarmColumn, Icon\AlarmBlank)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    ChangeIcon(#Gadget_AppointmentArchive_Appointments, LineNumber.i, Program\AlarmColumn, Icon\AlarmBlank)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 130
; FirstLine = 118
; Folding = -
; EnableXP
; HideErrorLog