﻿;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Procedure FindArchivedAppointmentNow()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SearchText.s  = GetGadgetText(#Gadget_AppointmentArchive_Search)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If SearchText.s <> ""
    
    QueryString.s = "SELECT * FROM Archive "                                 ; SELECT * FROM Appointments 
    
    QueryString.s + "WHERE appName LIKE '%"     + SearchText.s + "%' "       ; WHERE appName 
    
    QueryString.s + "OR appDate LIKE '%"        + SearchText.s + "%' "       ; WHERE 
    
    QueryString.s + "OR appTime LIKE '%"        + SearchText.s + "%' "       ; WHERE 
    
    QueryString.s + "OR appAlarm LIKE '%"       + SearchText.s + "%' "       ; WHERE 
    
    QueryString.s + "OR appRepeat LIKE '%"      + SearchText.s + "%' "       ; WHERE 
    
    QueryString.s + "OR appProtect LIKE '%"     + SearchText.s + "%' "       ; WHERE 
    
    QueryString.s + "OR appCategory LIKE '%"    + SearchText.s + "%' "       ; WHERE 
    
    QueryString.s + "OR appStatus LIKE '%"      + SearchText.s + "%' "       ; WHERE 
    
    QueryString.s + "OR appComment LIKE '%"     + SearchText.s + "%' "       ; WHERE 
    
    QueryString.s + "OR appArchived LIKE '%"    + SearchText.s + "%' "       ; WHERE 
    
    QueryString.s + "OR appEmailed LIKE '%"     + SearchText.s + "%' "       ; WHERE 
    
    QueryString.s + "OR appSound LIKE '%"       + SearchText.s + "%' "       ; WHERE 
    
    QueryString.s + "OR appDeleted LIKE '%"     + SearchText.s + "%' "       ; WHERE 
    
    QueryString.s + "OR appRecord LIKE '%"      + SearchText.s + "%' "       ; WHERE 
    
    QueryString.s + "ORDER BY appName ASC "                                  ; ORDER BY appDate
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetText(#Gadget_AppointmentArchive_Search, "")
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    QueryString.s = "SELECT * FROM Archive"                                  ; SELECT * FROM Appointments 
    
  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ClearGadgetItems(#Gadget_AppointmentArchive_Appointments)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ItemCounter.i = 0
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  With Appointment
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If DatabaseQuery(Program\DatabaseHandle,  QueryString.s)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      While NextDatabaseRow(Program\DatabaseHandle)
        
        \appName        = KillQuote(GetDatabaseString(Program\DatabaseHandle,   0))
        
        \appDate        =    IsoDate(GetDatabaseString(Program\DatabaseHandle,  1), "NormalDate")
        
        \appTime        =            GetDatabaseString(Program\DatabaseHandle,  2) 
        
        \appAlarm       =    IsoDate(GetDatabaseString(Program\DatabaseHandle,  3), "NormalDate")
        
        \appRepeat      =            GetDatabaseString(Program\DatabaseHandle,  4) 
        
        \appProtect     =            GetDatabaseString(Program\DatabaseHandle,  5) 
        
        \appCategory    =  KillQuote(GetDatabaseString(Program\DatabaseHandle,  6))
        
        \appStatus      =  KillQuote(GetDatabaseString(Program\DatabaseHandle,  7))
        
        \appComment     =  KillQuote(GetDatabaseString(Program\DatabaseHandle,  8))
        
        \appArchived    =  KillQuote(GetDatabaseString(Program\DatabaseHandle,  9))
        
        \appEmailed     =  KillQuote(GetDatabaseString(Program\DatabaseHandle, 10))
        
        \appSound       =  KillQuote(GetDatabaseString(Program\DatabaseHandle, 11))
        
        \appDeleted     =            GetDatabaseString(Program\DatabaseHandle, 12) 
        
        \appRecord      =            GetDatabaseString(Program\DatabaseHandle, 13) 
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        DisplayArchiveString(ItemCounter.i, "AddMode")
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        ItemCounter.i + 1
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetInfoBarArea("Headings", "Info",  "Showing: " + KillQuote(\appName))
        
        SetInfoBarArea("Records",  "",        Str(ItemCounter.i))
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        ClearStructure(@Appointment, AppointmentData)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Wend
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      FinishDatabaseQuery(Program\DatabaseHandle)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If CountGadgetItems(#Gadget_AppointmentArchive_Appointments) <> 0
        
        SetGadgetState(#Gadget_AppointmentArchive_Appointments, 0)
        
        PostEvent(#PB_Event_Gadget, #Window_AppointmentArchive, #Gadget_AppointmentArchive_Appointments, #PB_EventType_Change)
        
      Else
        
        ClearGadgetItems(#Gadget_AppointmentArchive_Appointments)
        
        SetGadgetText(#Gadget_AppointmentArchive_Comment, "")
                      
        SetInfoBarArea("Headings", "Info", "No records found for the [" + SearchText.s + " query.")
        
        SetInfoBarArea("Number",    "",    "?")
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Error", #InfoStringQueryFailed + DatabaseError())
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndWith
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

;   Else
;     
;     SetInfoBarArea("Headings",  "Info",  #InfoStringNoStringToFind)
;     
;   EndIf

; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 210
; FirstLine = 170
; Folding = -
; EnableXP
; HideErrorLog