﻿;========================================================================================================================================
; Show an RTF help file loaded into this window
;========================================================================================================================================

Procedure HelpAppointments()
  
  ;------------------------------------------------------------------------------------------------
  ; Check if the alarm module is running first
  ;------------------------------------------------------------------------------------------------
  
  If Program\DontCheck <> 1
    
    ;----------------------------------------------------------------------------------------------
    ; See if there is another window open still
    ;----------------------------------------------------------------------------------------------
    
    If Program\WindowMutex = 0
      
      ;--------------------------------------------------------------------------------------------
      ; Attempt to open the module window
      ;--------------------------------------------------------------------------------------------
      
      If Window_AppointmentHelp()
        
        ;------------------------------------------------------------------------------------------
        ; Set the window check flag so no others will open
        ;------------------------------------------------------------------------------------------
        
        Program\WindowMutex = 1
        
        ;------------------------------------------------------------------------------------------
        ; Warn other components that the alarm checker should not be run right now
        ;------------------------------------------------------------------------------------------
        
        Program\DontCheck = 1
        
        ;------------------------------------------------------------------------------------------
        ; Disable the main window
        ;------------------------------------------------------------------------------------------
        
        DisableWindow(#Window_AppointmentMuncher, 1)
        
        ;------------------------------------------------------------------------------------------
        ; Set the last window (and title message) string
        ;------------------------------------------------------------------------------------------
        
        Program\LastWindow = "Help for " + #Program
        
        ;------------------------------------------------------------------------------------------
        ; Set the window title here
        ;------------------------------------------------------------------------------------------
        
        SetWindowTitle(#Window_AppointmentHelp, Program\LastWindow)
        
        ;------------------------------------------------------------------------------------------
        ; Remove editorgadget borders
        ;------------------------------------------------------------------------------------------
        
        RemoveBorders(#Gadget_AppointmentHelp_HelpPage)
        
        ;------------------------------------------------------------------------------------------
        ; Add the various keyboard shortcuts
        ;------------------------------------------------------------------------------------------
        
        AddKeyboardShortcut(#Window_AppointmentHelp, #PB_Shortcut_Escape, #Shortcut_AppointmentHelp_Escape)
        
        ;------------------------------------------------------------------------------------------
        ; Stream the RTF 'about' data into the note area from the data section
        ;------------------------------------------------------------------------------------------
        
        CatchRTF(#Gadget_AppointmentHelp_HelpPage, ?_AppointmentMuncher_Help)
        
        ;------------------------------------------------------------------------------------------
        ; Display status to the user
        ;------------------------------------------------------------------------------------------
        
        SetInfoBarArea("Headings", "Info", Program\LastWindow)
        
        ;------------------------------------------------------------------------------------------
        ; Display status to the user
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Warn", #InfoStringCannotOpen)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Display status to the user
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Error", #InfoStringWindowOpen)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; Warn about the alarm checker still running
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Warn",  #InfoStringAlarmRunning)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 111
; FirstLine = 77
; Folding = -
; EnableXP