﻿;============================================================================================================================================================
; Write the error log to disk at program's end or when full
;============================================================================================================================================================

Procedure WriteErrorLog()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
    
  If ListSize(ErrorString()) <> 0
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    LogFileId.i = OpenFile(#PB_Any, Program\ErrorLogFile)
  
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If LogFileId.i <> 0
  
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      FileSeek(LogFileId.i, Lof(LogFileId.i))
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      WriteStringN(LogFileId.i, "")
      
      WriteStringN(LogFileId.i, "================================================================================")
      
      WriteStringN(LogFileId.i, "Report Date:  --  " + FormatDate("%dd/%mm/%yyyy", Date()))
      
      WriteStringN(LogFileId.i, "================================================================================")
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ForEach ErrorString()
  
        WriteStringN(LogFileId.i, ErrorString()\ModuleName + "  --  " + ErrorString()\ErrorMessage)
  
      Next
  
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      CloseFile(LogFileId.i)
  
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    EndIf
  
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    ; Don't need to write an error about not saving an empty list!!
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 27
; FirstLine = 42
; Folding = -
; EnableXP