﻿;==========================================================================================================================================================
; Save the new or edited appointment data
;==========================================================================================================================================================

Procedure SaveAppointmentData()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  With Appointment
    
    \appName        =                            RepQuote(GetGadgetText(#Gadget_AppointmentData_Itemname))    ;: Debug \appName
    
    \appDate        = FormatDate("%dd/%mm/%yyyy",         GetGadgetState(#Gadget_AppointmentData_cDatepick))  ;: Debug \appDate
    
    If GetGadgetState(#Gadget_AppointmentData_Timepick)  <> 0
      
      \appTime      = FormatDate("%hh:%ii",               GetGadgetState(#Gadget_AppointmentData_Timepick))   ;: Debug \appTime
    
    Else
      
      \appTime      = ""
      
    EndIf
  
    If GetGadgetState(#Gadget_AppointmentData_Alarmpick)  <> 0
      
      \appAlarm     = FormatDate("%dd/%mm/%yyyy",        GetGadgetState(#Gadget_AppointmentData_Alarmpick))  ;: Debug \appAlarm
      
    Else
      
      \appAlarm     = ""
      
    EndIf
    
    \appRepeat      =                                Str(GetGadgetState(#Gadget_AppointmentData_Repeat))      ;: Debug \appRepeat
    
    \appProtect     =                                Str(GetGadgetState(#Gadget_AppointmentData_Protected))   ;: Debug \appProtect
    
    \appCategory    =                            RepQuote(GetGadgetText(#Gadget_AppointmentData_Category))    ;: Debug \appCategory
    
    \appStatus      =                            RepQuote(GetGadgetText(#Gadget_AppointmentData_Itemstatus))  ;: Debug \appStatus
    
    \appComment     =                            RepQuote(GetRtfData(#Gadget_AppointmentData_Comment))        ;: Debug \appComment
    
    \appArchived    =                            RepQuote(GetGadgetText(#Gadget_AppointmentData_Archived))    ;: Debug \appArchived
    
    \appEmailed     =                            RepQuote(GetGadgetText(#Gadget_AppointmentData_Emailed))     ;: Debug \appEmailed
    
;   \appSound       =                            RepQuote(GetGadgetText(#Gadget_AppointmentData_Sound))       ;; Debug \appSound
    
;   \appDeleted     =                                                                                         ;: Debug \appDeleted

;   \appRecord      =                                                                                         ;: Debug \appRecord
    
  EndWith
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select Program\LastWindow
      
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Case  "Add New Appointment"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      With Appointment
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        \appArchived  = ""
        
        \appEmailed   = ""
        
        \appSound     = ""
        
        \appDeleted   = ""
  
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        QueryString.s = "INSERT INTO Appointments("
        
        QueryString.s + "appName, appDate, appTime, appAlarm, appRepeat, appProtect, appCategory, appStatus, "
        
        QueryString.s + "appComment, appArchived, appEmailed, appSound, appDeleted) "
        
        QueryString.s + "VALUES("
        
        QueryString.s + "'"   +         \appName               + "'"
        
        QueryString.s + ", '" + IsoDate(\appDate,  "IsoDate")  + "'"   ; Convert to international ISO date standard
        
        QueryString.s + ", '" +         \appTime               + "'"
        
        QueryString.s + ", '" + IsoDate(\appAlarm, "IsoDate")  + "'"   ; Convert to international ISO date standard
        
        QueryString.s + ", '" +         \appRepeat             + "'"
        
        QueryString.s + ", '" +         \appProtect            + "'"
        
        QueryString.s + ", '" +         \appCategory           + "'"
        
        QueryString.s + ", '" +         \appStatus             + "'"
        
        QueryString.s + ", '" +         \appComment            + "'"
        
        QueryString.s + ", '" +         \appArchived           + "'"
        
        QueryString.s + ", '" +         \appEmailed            + "'"
        
        QueryString.s + ", '" +         \appSound              + "'"
                        
        QueryString.s + ", '" +         \appDeleted            + "'"
        
        QueryString.s + ")"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
          
          \appRecord = DatabaseLastInsertRowId()
          
          If \appRecord <> ""
            
            NewNumberOfItems.i = CountGadgetItems(#Gadget_AppointmentMuncher_Appointments)
            
            DisplayAppointmentString(NewNumberOfItems.i,  "AddMode")
            
            If Setup\AutoArchive = 1
              
              ArchiveNewAppointment(\appRecord)
              
            EndIf
            
  ;           LastLine(#Gadget_AppointmentMuncher_Appointments, NewNumberOfItems.i)
  ;           
  ;           ; Set the currently highlighted line
  ;           
  ;           SetGadgetState(#Gadget_AppointmentMuncher_Appointments, NewNumberOfItems.i)
  ;           
  ;           DisplayRecordData()
            
          Else
            
            SetInfoBarArea("Headings",  "Error",  #InfoStringNoRecord + DatabaseError(), "SaveAppointmentData")
            
          EndIf
          
        Else
          
          SetInfoBarArea("Headings", "Error", #InfoStringUpdateFailed + DatabaseError(), "SaveAppointmentData")
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      EndWith
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case  "Edit Old Appointment"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      With Appointment
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        QueryString.s = "UPDATE Appointments SET "
        
        QueryString.s + "appName = '"         +         \appName               + "', "
        
        QueryString.s + "appDate = '"         + IsoDate(\appDate, "IsoDate")   + "', "
        
        QueryString.s + "appTime = '"         +         \appTime               + "', "
        
        QueryString.s + "appAlarm = '"        + IsoDate(\appAlarm, "IsoDate")  + "', "
        
        QueryString.s + "appRepeat = '"       +         \appRepeat             + "', "
        
        QueryString.s + "appProtect = '"      +         \appProtect            + "', "
        
        QueryString.s + "appCategory = '"     +         \appCategory           + "', "
        
        QueryString.s + "appStatus = '"       +         \appStatus             + "', "
        
        QueryString.s + "appComment = '"      +         \appComment            + "'  "
        
;       QueryString.s + "appArchived = '"     +         \appArchived           + "'  "
        
;       QueryString.s + "appEmailed = '"      +         \appEmailed            + "'  "
        
;       QueryString.s + "appSound = '"        +         \appSound              + "'  "
        
;       QueryString.s + "appDeleted = '"      +         \appDeleted            + "' "
        
        QueryString.s + "WHERE appRecord = '" +         Program\CurrentRecord  + "'"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
          
          DisplayAppointmentString(Program\CurrentLine, "EditMode")
          
          If Setup\AutoArchive = 1
            
            UpdateArchivedAppointment(Program\CurrentRecord)
            
          EndIf
            
        Else
          
          SetInfoBarArea("Headings", "Error", #InfoStringUpdateFailed + DatabaseError(), "SaveAppointmentData")
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
      
      EndWith
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CloseMyWindow(#Window_AppointmentData)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 252
; FirstLine = 227
; Folding = -
; EnableXP