﻿;==========================================================================================================================================================
; Try to open the system database and create missing tables
;==========================================================================================================================================================

Procedure OpenSystemDatabase()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  FileHandle.i = OpenFile(#PB_Any, Program\DatabaseName)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If FileHandle.i
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CloseFile(FileHandle.i)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\DatabaseHandle = OpenDatabase(#PB_Any, Program\DatabaseName, "", "")
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
  
    If Program\DatabaseHandle
      
      QueryString.s = "PRAGMA auto_vacuum = on"
      
      ; Turn on auto database vacuum
      
      If Not DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
        
        MessageRequester("Vacuum setup error", "Could not setup auto database vacuum.")
        
        ProcedureReturn
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Write the appointments table out
      ;--------------------------------------------------------------------------------------------
      
      QueryString.s = "CREATE TABLE IF NOT EXISTS Appointments("
      
      QueryString.s + "appName TEXT, appDate TEXT, appTime TEXT, appAlarm TEXT, appRepeat TEXT, "
      
      QueryString.s + "appProtect TEXT, appCategory TEXT, appStatus TEXT, appComment TEXT, "
      
      QueryString.s + "appArchived TEXT, appEmailed TEXT, appSound TEXT, appDeleted TEXT, "
      
      QueryString.s + "appRecord INTEGER PRIMARY KEY AUTOINCREMENT, "

      QueryString.s + "UNIQUE(appName, appDate, appTime, appRepeat, appComment, appCategory))"
      
      If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
        
      EndIf

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If Not DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
        
        MessageRequester("Table creation error", "Could not create tables in database.")
        
        ProcedureReturn
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Write the appointments table out
      ;--------------------------------------------------------------------------------------------
      
      QueryString.s = "CREATE TABLE IF NOT EXISTS Archive("
      
      QueryString.s + "appName TEXT, appDate TEXT, appTime TEXT, appAlarm TEXT, appRepeat TEXT, "
      
      QueryString.s + "appProtect TEXT, appCategory TEXT, appStatus TEXT, appComment TEXT, "
      
      QueryString.s + "appArchived TEXT, appEmailed TEXT, appSound TEXT, appDeleted TEXT, "
      
      QueryString.s + "appRecord INTEGER PRIMARY KEY AUTOINCREMENT, "

      QueryString.s + "UNIQUE(appRecord))"
      
      If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
        
      EndIf

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If Not DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
        
        MessageRequester("Table creation error", "Could not create tables in database.")
        
        ProcedureReturn
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Write the appointments table out
      ;--------------------------------------------------------------------------------------------
      
      QueryString.s = "CREATE TABLE IF NOT EXISTS Setup("
      
      QueryString.s + "Titleclock TEXT, Stickywindow TEXT, Tooltips TEXT, Screensnap TEXT, "
      
      QueryString.s + "EmailAlarm TEXT, AutoArchive TEXT, StartupDates TEXT, SnoozePeriod TEXT, "
      
      QueryString.s + "AlarmSound TEXT, LastSearch TEXT, ServerName TEXT, PortNumber TEXT, "
      
      QueryString.s + "UserName TEXT, Password TEXT, NeedSsl TEXT, EmailAddress TEXT, "
      
      QueryString.s + "SetupRecord INTEGER PRIMARY KEY AUTOINCREMENT)"

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      
      If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
        
        If CountRecords("SetupRecord", "Setup") = "0"
          
          QueryString.s = "INSERT INTO Setup(Titleclock, Stickywindow, Tooltips, Screensnap, "
          
          QueryString.s + "EmailAlarm, AutoArchive, StartupDates, SnoozePeriod, AlarmSound, "
          
          QueryString.s + "LastSearch, ServerName, PortNumber, UserName, Password, NeedSsl, "
          
          QueryString.s + "EmailAddress) "
          
          QueryString.s + "VALUES('0', '0', '0', '0', '0', '0', '0', '0'. '0', "
          
          QueryString.s + "'', '', '', '', '', '', '')"
          
          DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
          
        EndIf
        
      Else
        
        MessageRequester("Table creation error", "Could not create tables in database.")
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      MessageRequester("Database open error", "There was a serious problem attempting to connect to the system database. Could be corrupt or open by some other process. Exit Hive and try again.", #PB_MessageRequester_Ok)
      
      ProcedureReturn
      
    EndIf 
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    MessageRequester("Database file open error", "Could not open or create raw database file.", #PB_MessageRequester_Ok)
    
    ProcedureReturn
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure

; IDE Options = PureBasic 5.23 LTS (Windows - x86)
; CursorPosition = 94
; FirstLine = 46
; Folding = -
; EnableXP