﻿;==========================================================================================================================================================
; Remove borders from various gadgets
;==========================================================================================================================================================

Procedure RemoveBorders(GadgetConstant.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Get the gadget type from the passed gadget constant
  ;------------------------------------------------------------------------------------------------

  GadgetType.i = GadgetType(GadgetConstant.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Select the gadget type
  ;------------------------------------------------------------------------------------------------
  
  Select GadgetType.i
      
    ;----------------------------------------------------------------------------------------------
    ; Do the below if it is a ListIconGadget
    ;----------------------------------------------------------------------------------------------
    
    Case  #PB_GadgetType_ListIcon
      
      ;--------------------------------------------------------------------------------------------
      ; Remove borders from ListIconGadgets
      ;--------------------------------------------------------------------------------------------
      
      OldStyle.i = GetWindowLongPtr_(GadgetID(GadgetConstant.i), #GWL_EXSTYLE)
      
      NewStyle.i = OldStyle.i & ( ~ #WS_EX_CLIENTEDGE)
      
      SetWindowLongPtr_(GadgetID(GadgetConstant.i), #GWL_EXSTYLE, NewStyle.i)
      
      SetWindowPos_(GadgetID(GadgetConstant.i), 0, 0, 0, 0, 0, #SWP_SHOWWINDOW | #SWP_NOSIZE | #SWP_NOMOVE | #SWP_FRAMECHANGED)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------

    Case #PB_GadgetType_Editor
      
      ;--------------------------------------------------------------------------------------------
      ; Remove border from editorgadget (comment) field. Stiil leaves a 1 pixel border but that looks good here
      ;--------------------------------------------------------------------------------------------
      
      SetWindowLongPtr_(GadgetID(GadgetConstant.i), #GWL_EXSTYLE, GetWindowLongPtr_(GadgetID(GadgetConstant.i), #GWL_EXSTYLE) & (~#WS_EX_CLIENTEDGE))
      
      SetWindowPos_(GadgetID(GadgetConstant.i), 0, 0, 0, 0, 0, #SWP_SHOWWINDOW | #SWP_NOSIZE | #SWP_NOMOVE | #SWP_FRAMECHANGED)
  
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure

; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 32
; FirstLine = 13
; Folding = -
; EnableXP