﻿;==========================================================================================================================================================
; Decode
;==========================================================================================================================================================

Procedure ProcessAppointmentNode(*CurrentNode, CurrentSublevel.i)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If XMLNodeType(*CurrentNode) = #PB_XML_Normal
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    *ChildNode = ChildXMLNode(*CurrentNode)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    While *ChildNode <> 0
      
      ;--------------------------------------------------------------------------------------------
      ; Returns the tagname of the given XML node;
      ;--------------------------------------------------------------------------------------------
      
      NodeName.s =                    GetXMLNodeName(*ChildNode)
      
      ;--------------------------------------------------------------------------------------------
      ; Returns the text inside the given XML node.
      ;--------------------------------------------------------------------------------------------
      
      NodeText.s = Trim(RepQuote(XMLToText(GetXMLNodeText(*ChildNode))))
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
      If NodeName.s <> "appRecord"                                          ;   A known last column
        
        OutPutString.s  + "'" + NodeText.s  + "',"
        
        TableString.s   +       NodeName.s  + ","
        
      Else
        
        OutPutString.s  = Left(OutPutString.s,  Len(OutPutString.s)   - 1)  ; : Debug OutPutString.s
        
        TableString.s   = Left(TableString.s,   Len(TableString.s)    - 1)  ; : Debug TableString.s
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
        QueryString.s = "INSERT INTO Appointments ("
        
        QueryString.s + TableString.s   + ") VALUES("
        
        QueryString.s + OutPutString.s  + ")"
        
        If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
          
          SetInfoBarArea("Headings",  "Info",  #InfoStringImportImportLine)
          
        Else
          
          SetInfoBarArea("Headings",  "Info",  #InfoStringImportImportNoLine + DatabaseError(), "ProcessAppointmentNode")

        EndIf
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
      ProcessAppointmentNode(*ChildNode, CurrentSublevel.i + 1)
      
      *ChildNode = NextXMLNode(*ChildNode)
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
EndProcedure 


; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 68
; FirstLine = 65
; Folding = -
; EnableXP