﻿;==========================================================================================================================================================
; Add balloon tooltips with individual fonts and icons
;==========================================================================================================================================================

Procedure BalloonTip(pbGadgetNumber.i, pbFontHandle.i, balloonColour.i, balloonTipTitle.s, balloonTipText.s,  pbIconHandle.i)
  
  ;------------------------------------------------------------------------------------------------
  ; If the tooltip already exists, just exit this procedure
  ;------------------------------------------------------------------------------------------------
  
  ForEach Balloon()
    
    If Balloon()\pbGadgetNumber = pbGadgetNumber.i
      
      ProcedureReturn
      
    EndIf
    
  Next
  
  ;------------------------------------------------------------------------------------------------
  ; Add the new tooltip to the handling procedure
  ;------------------------------------------------------------------------------------------------
  
  AddElement(Balloon())
  
  Balloon()\handleTip       = CreateWindowEx_(0, "ToolTips_Class32", "", #WS_POPUP | #TTS_NOPREFIX | #TTS_BALLOON, 0, 0, 0, 0, GadgetID(pbGadgetNumber.i), 0, GetModuleHandle_(0), 0)
  
  Balloon()\pbGadgetID      = GadgetID(pbGadgetNumber.i)
  
  Balloon()\pbGadgetNumber  = pbGadgetNumber.i
  
  Balloon()\pbIconHandle    = pbIconHandle.i
  
  ;------------------------------------------------------------------------------------------------
  ; Set the tooltip parameters
  ;------------------------------------------------------------------------------------------------
  
  SetWindowTheme_(Balloon()\handleTip,  @null.w,  @null.w)
    
  SendMessage_(Balloon()\handleTip, #WM_SETFONT,  FontID(pbFontHandle.i), 0)
  
  SendMessage_(Balloon()\handleTip, #TTM_SETTIPTEXTCOLOR, $000000,        0)
  
  SendMessage_(Balloon()\handleTip, #TTM_SETTIPBKCOLOR,  balloonColour.i, 0)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Balloon\cbSize    = SizeOf(Balloon)
  
  Balloon\uFlags    = #TTF_IDISHWND | #TTF_SUBCLASS
  
  Balloon\hWnd      = GadgetID(pbGadgetNumber.i)
  
  Balloon\uId       = GadgetID(pbGadgetNumber.i)
  
  Balloon\lpszText  = @balloonTipText
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(Balloon()\handleTip,  #TTM_ADDTOOL,   0,  Balloon)
  
  SendMessage_(Balloon()\handleTip,  #TTM_SETTITLE,  Balloon()\pbIconHandle,  @balloonTipTitle)
  
  ;------------------------------------------------------------------------------------------------
  ; End the procedure
  ;------------------------------------------------------------------------------------------------

EndProcedure

; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 73
; Folding = -
; EnableXP