﻿;============================================================================================================================================================
; Alias the search type text to SQLite operators
;============================================================================================================================================================

Procedure.s SetSearchQuery(SearchOperator.s, SearchString.s)
  Select SearchOperator.s
    Case "Equal to"                 : QueryString.s = " = '"      + SearchString.s + "'"
    Case "Does not equal"           : QueryString.s = " <> '"     + SearchString.s + "'"
    Case "Greater than"             : QueryString.s = " > '"      + SearchString.s + "'"
    Case "Greater than or equal to" : QueryString.s = " >= '"     + SearchString.s + "'"
    Case "Less than"                : QueryString.s = " < '"      + SearchString.s + "'"
    Case "Less than or equal to"    : QueryString.s = " <= '"     + SearchString.s + "'"
    Case "Starts with"              : QueryString.s = " LIKE '%"  + SearchString.s + "'"
    Case "Ends with"                : QueryString.s = " LIKE '"   + SearchString.s + "%'"
    Case "Sounds like"              : QueryString.s = " LIKE '%"  + SearchString.s + "%'"
  EndSelect
  ProcedureReturn QueryString.s
EndProcedure

  SearchType.s    = "Sounds like"
  SearchText.s    = "load of old bollocks"
  SearchCommand.s = SetSearchQuery(SearchType.s, SearchText.s)
  SearchField.s   = "Appointment name"
  SortField.s     = "Category type"
  SearchOrder.s   = "ASC "
  SearchLimit.s   = "12"
  
  Select SearchField.s
    Case  "Appointment name"      : SearchField.s = "appName "
    Case  "Date to execute"       : SearchField.s = "appDate "
    Case  "Time of day"           : SearchField.s = "appTime "
    Case  "Alarm Set"             : SearchField.s = "appAlarm "
    Case  "Category type"         : SearchField.s = "appCategory "
    Case  "Status of appointment" : SearchField.s = "appStatus "
    Case  "Extra comments"        : SearchField.s = "appComment "
    Case  "Marked deleted or not" : SearchField.s = "appDeleted "
    Case  "Record number"         : SearchField.s = "appRecord "
  EndSelect
  
  Select SortField.s
    Case  "Appointment name"      : SortField.s = "appName "
    Case  "Date to execute"       : SortField.s = "appDate "
    Case  "Time of day"           : SortField.s = "appTime "
    Case  "Alarm Set"             : SortField.s = "appAlarm "
    Case  "Category type"         : SortField.s = "appCategory "
    Case  "Status of appointment" : SortField.s = "appStatus "
    Case  "Extra comments"        : SortField.s = "appComment "
    Case  "Maked deleted or not"  : SortField.s = "appDeleted "
    Case  "Record number"         : SortField.s = "appRecord "
  EndSelect


  Query.s = "SELECT * FROM Appointments WHERE "
  Query.s + SearchField.s + SearchCommand.s
  Query.s + "ORDER BY "   + SortField.s
  Query.s + SearchOrder.s
  Query.s + "LIMIT "      + SearchLimit.s

  Debug Query.s
; IDE Options = PureBasic 5.22 LTS (Windows - x86)
; CursorPosition = 35
; FirstLine = 15
; Folding = -
; EnableXP